"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StrapiAuthLogin = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeWebview = require("react-native-webview");

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const StrapiAuthLogin = _ref => {
  let {
    isVisisble,
    lang,
    redirectUrl,
    backendUrl,
    provider,
    onCancel,
    onSuccess,
    onError,
    cancelBtnText,
    cancelBtnTextColor,
    cancelBtnBgColor
  } = _ref;
  const webView = (0, _react.useRef)(null);
  const providerUrl = `${backendUrl}/api/connect/${provider}`;
  const patchPostMessageJsCode = `(${String(function () {
    // @ts-ignore
    var originalPostMessage = window.postMessage;

    var patchedPostMessage = function (message, targetOrigin, transfer) {
      originalPostMessage(message, targetOrigin, transfer);
    };

    patchedPostMessage.toString = function () {
      return String(Object.hasOwnProperty).replace('hasOwnProperty', 'postMessage');
    }; // @ts-ignore


    window.postMessage = patchedPostMessage;
  })})();`;

  const onNavigationStateChange = async event => {
    if (event.url.startsWith(redirectUrl)) {
      var _webView$current;

      (_webView$current = webView.current) === null || _webView$current === void 0 ? void 0 : _webView$current.stopLoading();
      let regex = /[?&]([^=#]+)=([^&#]*)/g;
      const params = Object.fromEntries([...event.url.matchAll(regex)].map(m => [m[1], m[2]]));
      const {
        access_token
      } = params;

      if (access_token) {
        try {
          const response = await _axios.default.get(`${backendUrl}/api/auth/${provider}/callback`, {
            params: {
              access_token: `${access_token}`
            }
          });
          onSuccess(response.data);
        } catch (error) {
          if (_axios.default.isAxiosError(error)) {
            if (error.response) onError(error.response.data);
          } else {
            if (error instanceof Error) onError(error.message);else onError('Unknown error');
          }
        }
      } else onError('No access token found');
    }
  };

  return /*#__PURE__*/_react.default.createElement(_reactNative.Modal, {
    visible: isVisisble,
    animationType: "slide"
  }, /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: {
      height: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    style: {
      backgroundColor: cancelBtnBgColor ?? 'transparent',
      justifyContent: 'center',
      position: 'absolute',
      bottom: '2%',
      zIndex: 1,
      alignSelf: 'center',
      padding: 12,
      borderRadius: 10
    },
    onPress: onCancel
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: {
      textAlign: 'center',
      color: cancelBtnTextColor ?? 'rgba(180, 180, 180, 1.000)'
    }
  }, cancelBtnText ?? 'Close')), /*#__PURE__*/_react.default.createElement(_reactNativeWebview.WebView, {
    userAgent: _reactNative.Platform.OS === 'android' ? 'Chrome/103.0.0.0 Mobile Safari/537.36' : 'AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/103.0.5060.63 Mobile/15E148 Safari/604.1',
    ref: webView,
    source: {
      uri: providerUrl,
      headers: {
        'Accept-Language': lang ?? 'en'
      }
    },
    startInLoadingState: true,
    onError: err => console.log({
      err
    }),
    onMessage: msg => console.log({
      msg
    }),
    onNavigationStateChange: onNavigationStateChange,
    injectedJavaScript: patchPostMessageJsCode
  })));
};

exports.StrapiAuthLogin = StrapiAuthLogin;
//# sourceMappingURL=LoginWithStrapi.js.map