import { AxiosError } from 'axios';
export declare type Payload = {
    jwt: string;
    user: {
        id: number;
        email: string;
        username: string;
        confirmed: boolean;
        blocked: boolean;
        createdAt: string;
        updatedAt: string;
        provider?: Providers;
    };
};
export declare type ErrorPayload = {
    data: null;
    error: {
        message: string;
        status: number;
        name: string;
        details: {
            [k: string]: string;
        };
    };
};
export declare type Providers = 'instagram' | 'facebook' | 'google' | 'twitter' | 'linkedin' | 'github' | 'cognito' | 'discord' | 'twitch' | 'reddit' | 'vk' | 'auth0' | 'cas';
export declare type Languages = 'en' | 'ar' | 'fr' | 'cs' | 'de' | 'dk' | 'es' | 'he' | 'id' | 'it' | 'ja' | 'ko' | 'ms' | 'nl' | 'no' | 'pl' | 'pt-BR' | 'pt' | 'ru' | 'sk' | 'sv' | 'th' | 'tr' | 'uk' | 'vi' | 'zh-Hans' | 'zh';
declare type CancelBtnColorProp = `#${number}` | `rgba(${number}, ${number}, ${number}, ${number})`;
declare type Props = {
    lang?: Languages;
    provider: Providers;
    redirectUrl: string;
    backendUrl: string;
    isVisisble: boolean;
    onCancel: () => void;
    onSuccess: (payload: Payload) => void;
    onError: (error: string | AxiosError<ErrorPayload>) => void;
    cancelBtnText?: CancelBtnColorProp;
    cancelBtnTextColor?: CancelBtnColorProp;
    cancelBtnBgColor?: CancelBtnColorProp;
};
export declare const StrapiAuthLogin: ({ isVisisble, lang, redirectUrl, backendUrl, provider, onCancel, onSuccess, onError, cancelBtnText, cancelBtnTextColor, cancelBtnBgColor, }: Props) => JSX.Element;
export {};
